#ifndef CONSUMER_H
#define CONSUMER_H

#include "monitor.h"
#include <QThread>
#include <QSemaphore>

template<typename T>
class Consumer : public QThread {
private:
    int ID;
    static Monitor<T> *mon;
    static QSemaphore numProducts;
public:
    static void (*consume)(T i, int);
    static void initClass(int numP, Monitor<T> *m, void (*cons)(T, int));

    Consumer<T>(int i) : ID(i) {}
    void run();
};

#endif // CONSUMER_H
