#ifndef PRODUCER_H
#define PRODUCER_H
#include "monitor.h"
#include <QThread>
#include <QSemaphore>

template<typename T>
class Producer : public QThread {
private:
    static QSemaphore numProducts;
    int ID;
    static Monitor<T> *mon;
public:
    static T(*produce)(int);
    static void initClass(int numP, Monitor<T> *m, T(*prod)(int));

    Producer<T>(int i) : ID(i) {}
    void run();
};

#endif // PRODUCER_H
